///////////////////////////////////////////////////////////////////////////////
//
//  Datei : Sample1Dlg.cpp
//  Autor : Harald Krause PMS AG
//  Zweck : Sample DISTO online Automatisation Interface C++
//
///////////////////////////////////////////////////////////////////////////////
//
//  Beschreibung
//
//
///////////////////////////////////////////////////////////////////////////////
//
//  Revisionsgeschichte
//
//  ## YY-MM-DD by Kommentar
//  --+--+--+--+--+------------------------------------------------------------
//  00 02-04-09 HK start
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
//	Includes
//

#include "stdafx.h"
#include "afxdisp.h"
#include "Sample1.h"
#include "Sample1Dlg.h"

#include "DlgModelessInfo.h"


///////////////////////////////////////////////////////////////////////////////
//	Defines
//

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//	Helper Macros
#define EnableCtrl(id)			(GetDlgItem(id)->EnableWindow())
#define DisableCtrl(id)			(GetDlgItem(id)->EnableWindow(0))
#define	IsChecked(id)			(((CButton *)GetDlgItem(id))->GetState() & 0x03)
#define SetChecked(id,iFlag)	(((CButton *)GetDlgItem(id))->SetCheck(iFlag))


///////////////////////////////////////////////////////////////////////////////
//	Statics
//

///////////////////////////////////////////////////////////////////////////////
//	Exports
//

///////////////////////////////////////////////////////////////////////////////
//	Implementation
//


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSample1Dlg Dialogfeld

CSample1Dlg::CSample1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSample1Dlg)
	m_CStringDistoSerialNumber = _T("");
	m_CStringResult = _T("");
	m_iTimeout = 5;
	m_CStringUnlockCode = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bDistoOnlineStarted = false;
}

void CSample1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSample1Dlg)
	DDX_Text(pDX, IDC_EDIT_DISTO_SERIAL_NUMBER, m_CStringDistoSerialNumber);
	DDX_Text(pDX, IDC_EDIT_RESULT, m_CStringResult);
	DDX_Text(pDX, IDC_EDIT_TIMEOUT, m_iTimeout);
	DDX_Text(pDX, IDC_EDIT_UNLOCK_CODE, m_CStringUnlockCode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSample1Dlg, CDialog)
	//{{AFX_MSG_MAP(CSample1Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_LASER_ON, OnButtonLaserOn)
	ON_BN_CLICKED(IDC_BUTTON_LASER_OFF, OnButtonLaserOff)
	ON_BN_CLICKED(IDC_BUTTON_FIND_DISTO, OnButtonFindDisto)
	ON_BN_CLICKED(IDC_BUTTON_REGISTER, OnButtonRegister)
	ON_BN_CLICKED(IDC_BUTTON_SINGLE_MEASUREMENT, OnButtonSingleMeasurement)
	ON_BN_CLICKED(IDC_CHECK_VISIBLE, OnCheckVisible)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CSample1Dlg::UpdateControls()
{
	if(!m_bDistoOnlineStarted)	
	{
		EnableCtrl(IDC_BUTTON_START);
		DisableCtrl(IDC_BUTTON_LASER_ON);
		DisableCtrl(IDC_BUTTON_LASER_OFF);
		DisableCtrl(IDC_BUTTON_FIND_DISTO);
		DisableCtrl(IDC_BUTTON_REGISTER);
		DisableCtrl(IDC_BUTTON_SINGLE_MEASUREMENT);
		DisableCtrl(IDC_CHECK_VISIBLE);
	}
	else
	{
		DisableCtrl(IDC_BUTTON_START);
		EnableCtrl(IDC_BUTTON_LASER_ON);
		EnableCtrl(IDC_BUTTON_LASER_OFF);
		EnableCtrl(IDC_BUTTON_FIND_DISTO);
		EnableCtrl(IDC_BUTTON_REGISTER);
		EnableCtrl(IDC_BUTTON_SINGLE_MEASUREMENT);
		EnableCtrl(IDC_CHECK_VISIBLE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSample1Dlg Nachrichten-Handler

BOOL CSample1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	SetChecked(IDC_CHECK_VISIBLE,TRUE);

	UpdateControls();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CSample1Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CSample1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CSample1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSample1Dlg::OnButtonStart() 
{
	m_bDistoOnlineStarted = true;
	COleException *e = new COleException;

	UpdateControls();

	try
	{
		if(m_DistoApplication.CreateDispatch("Disto2.Application"),e)
		{
			//	Check for DISTOs
			CWaitCursor aWaitCursor;
			
			CDlgModelessInfo* pInfo = ShowModelessInfo(_T("Suche nach DISTOs...\nLooking for DISTOs..."));

			Sleep(500);

			int bDistoConnected = m_DistoApplication.IsDistoConnected(50);

			pInfo->DestroyWindow();

			if(!bDistoConnected)
			{
				AfxMessageBox(_T("Kein DISTO angeschlossen!\nNo DISTO connected!"));
			}
			else
			{
				Sleep(100);							//	Give DISTO some time to settle down
				m_CStringDistoSerialNumber = m_DistoApplication.DistoSerialnumber();
				UpdateData(FALSE);
			}
		}
		else
		{
			throw e;
		}
	}
	catch(COleDispatchException * e)
	{
		CString cStr(_T("Kann DISTO online nicht starten\nCouldn't start DISTO online\n"));
			
		if (!e->m_strSource.IsEmpty())			cStr += e->m_strSource + " - ";
		if (!e->m_strDescription.IsEmpty())		cStr += e->m_strDescription;
		else									cStr += "unknown error";
			
		AfxMessageBox(cStr, MB_OK,(e->m_strHelpFile.IsEmpty())? 0:e->m_dwHelpContext);
	}
}

void CSample1Dlg::OnButtonLaserOn() 
{
	m_DistoApplication.LaserOn();	
}

void CSample1Dlg::OnButtonLaserOff() 
{
	m_DistoApplication.LaserOff();	
}

void CSample1Dlg::OnCheckVisible() 
{
	m_DistoApplication.SetBvisible(IsChecked(IDC_CHECK_VISIBLE));
}

void CSample1Dlg::OnButtonFindDisto() 
{
	CWaitCursor aWaitCursor;

	CDlgModelessInfo* pInfo = ShowModelessInfo(_T("Suche nach DISTOs...\nLooking for DISTOs..."));
	
	m_DistoApplication.FindDisto();

	Sleep(100);								//	Give DISTO some time to settle down

	pInfo->DestroyWindow();
	m_CStringDistoSerialNumber = m_DistoApplication.DistoSerialnumber();
	UpdateData(FALSE);
}

void CSample1Dlg::OnButtonRegister() 
{
	UpdateData();
	m_DistoApplication.DistoAccessCode(m_CStringUnlockCode);
	
	AfxMessageBox("Freischaltcode gesetzt\nUnclock Code set");
}

void CSample1Dlg::OnButtonSingleMeasurement() 
{
	UpdateData();
	
	IDistoMeasureProxy aMeasure(m_DistoApplication.SingleMeasure(m_iTimeout));

	if(aMeasure.IsValid())
	{
		CString cstrValue;
		cstrValue.Format(_T("%f"),aMeasure.Value());

		m_CStringResult.FormatMessage(_T(	"Zeit/Time: %1\n"
											"Value    : %2\n"),
									  aMeasure.TimeMS(),
									  cstrValue);
	}
	else
	{
		if(aMeasure.IsTimeout())		m_CStringResult = _T("Leica DISTO Timeout");
		else if(aMeasure.ErrorCode())	m_CStringResult = aMeasure.ErrorString();
		else							m_CStringResult = _T("Unknown DISTO Error");
	}
	UpdateData(FALSE);
}


/* EOF */
