// Sample2Dlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Sample2.h"
#include "Sample2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSample2Dlg Dialogfeld

CSample2Dlg::CSample2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSample2Dlg)
	m_Code = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSample2Dlg)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	DDX_Text(pDX, IDC_EDIT_CODE, m_Code);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSample2Dlg, CDialog)
	//{{AFX_MSG_MAP(CSample2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DIST, OnButtonDist)
	ON_BN_CLICKED(IDC_BUTTON_DISTANG, OnButtonDistang)
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CSample2Dlg::StartDisto()
{
	COleException *e = new COleException;
	
	try
	{
		if(m_Disto.CreateDispatch("Disto2.Application"),e)
		{
			//	Check for DISTOs
			CWaitCursor aWaitCursor;
			
			Sleep(500);
			
			int bDistoConnected = m_Disto.IsDistoConnected(50);
			
			if(!bDistoConnected)
			{
				m_ListBox.AddString(_T("Kein DISTO angeschlossen!\nNo DISTO connected!"));
			}
			else
			{
				Sleep(150);							//	Give DISTO some time to settle down
				m_ListBox.AddString(_T("Disto  ") + m_Disto.DistoSerialnumber());

				GetDlgItem(IDC_BUTTON_SET)->EnableWindow(1);
				GetDlgItem(IDC_BUTTON_DIST)->EnableWindow(1);
				GetDlgItem(IDC_BUTTON_DISTANG)->EnableWindow(1);
				GetDlgItem(IDC_BUTTON_START)->EnableWindow(0);
			}
		}
		else
		{
			throw e;
		}
	}
	catch(COleDispatchException * e)
	{
		m_ListBox.AddString(_T("Kann DISTO online nicht starten"));
		m_ListBox.AddString(_T("Couldn't start DISTO online"));

		if (!e->m_strSource.IsEmpty())			m_ListBox.AddString(e->m_strSource);
		if (!e->m_strDescription.IsEmpty())		m_ListBox.AddString(e->m_strDescription);
		else									m_ListBox.AddString("unknown error");
		AfxMessageBox("Error");
	}

}

/////////////////////////////////////////////////////////////////////////////
// CSample2Dlg Nachrichten-Handler

BOOL CSample2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	GetDlgItem(IDC_BUTTON_SET)->EnableWindow(0);
	GetDlgItem(IDC_BUTTON_DIST)->EnableWindow(0);
	GetDlgItem(IDC_BUTTON_DISTANG)->EnableWindow(0);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CSample2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CSample2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSample2Dlg::OnButtonDist() 
{
	m_Disto.SetSendModeProtokollOnly();

	IDistoMeasureProxy aMeasure(m_Disto.SingleMeasure(500));
	
	if(aMeasure.IsValid())
	{
		CString cstrValue;
		CString Result;

		cstrValue.Format(_T("%f"),aMeasure.Value());
		
		Result.FormatMessage(_T("Zeit/Time: %1   Value: %2 %3"),	aMeasure.TimeMS(),cstrValue,aMeasure.Unit());
		m_ListBox.AddString(Result);

	}
	else
	{
		if(aMeasure.IsTimeout())		m_ListBox.AddString(_T("Leica DISTO Timeout"));
		else if(aMeasure.ErrorCode())	m_ListBox.AddString(aMeasure.ErrorString());
		else							m_ListBox.AddString(_T("Unknown DISTO Error"));
	}
	
}

void CSample2Dlg::OnButtonDistang() 
{
	m_Disto.SetSendModeProtokollOnly();

//	m_Disto.StartSingleMeasureAngle();

	IDistoMeasureProxy aMeasure(m_Disto.SingleMeasureAngle(500));
	
	if(aMeasure.IsValid())
	{
		CString cstrValue;
		CString cstrAngle;

		CString Result;
		
		cstrValue.Format(_T("%f"),aMeasure.Value());
		
		if(aMeasure.IsAngle())
		{
			cstrAngle.Format(_T("%f %s"),aMeasure.Angle(),aMeasure.AngleUnit());
		}
		else
		{
			cstrAngle = "Angle Error";
		}

		
		Result.FormatMessage(_T("Zeit/Time: %1   Value: %2 %3 %4"),	
								aMeasure.TimeMS(),cstrValue,aMeasure.Unit(),cstrAngle);
		m_ListBox.AddString(Result);
		
	}
	else
	{
		if(aMeasure.IsTimeout())		m_ListBox.AddString(_T("Leica DISTO Timeout"));
		else if(aMeasure.ErrorCode())	m_ListBox.AddString(aMeasure.ErrorString());
		else							m_ListBox.AddString(_T("Unknown DISTO Error"));
	}	
}

void CSample2Dlg::OnButtonStart() 
{
	StartDisto();
}

void CSample2Dlg::OnButtonSet() 
{
	UpdateData(TRUE);
	m_Disto.DistoAccessCode(m_Code);
}
